// H8_JPEGDlg.cpp : t@C
//

#include "stdafx.h"
#include "H8_JPEG.h"
#include "H8_JPEGDlg.h"
#include "WaitResp.h"
#include "InitCamera.h"
#include "GetPicture.h"

#include<olectl.h>
#include <time.h>
#include <winsock2.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define MAX_LOADSTRING	100
#define HIMETRIC_INCH	2540
#define MAP_LOGHIM_TO_PIX(x,ppli)   ( ((ppli)*(x) + HIMETRIC_INCH/2) / HIMETRIC_INCH )


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CH8_JPEGDlg _CAO




CH8_JPEGDlg::CH8_JPEGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CH8_JPEGDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CH8_JPEGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CH8_JPEGDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SAVE_INI, &CH8_JPEGDlg::OnBnClickedButtonSaveIni)
	ON_BN_CLICKED(IDOK, &CH8_JPEGDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON_OPEN_JPEG_FILE, &CH8_JPEGDlg::OnBnClickedButtonOpenJpegFile)
	ON_BN_CLICKED(IDCANCEL, &CH8_JPEGDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON_CAMERA_INIT, &CH8_JPEGDlg::OnBnClickedButtonCameraInit)
	ON_BN_CLICKED(IDC_BUTTON_GET_PICTURE, &CH8_JPEGDlg::OnBnClickedButtonGetPicture)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, &CH8_JPEGDlg::OnBnClickedButtonDisconnect)
END_MESSAGE_MAP()


// CH8_JPEGDlg bZ[W nh

BOOL CH8_JPEGDlg::OnInitDialog()
{
	DWORD	dwRet = 0;
	WSADATA	wsaData;

	CDialog::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	//@摜̃IuWFNg݂邩`FbN
	if (iPicture)
		iPicture->Release();

	// ÑftHg摜[h
	LoadPictureFile(_TEXT("Default.jpg"));

	memset(g_szCurrentDirectory, 0, sizeof(g_szCurrentDirectory));
	dwRet = GetCurrentPath(g_szCurrentDirectory);
	if (dwRet) {
		// JPEGtH_쐬
		dwRet = CreateJpegStorFolder(g_szCurrentDirectory);
	}

	// .ini t@CpX쐬
	memset(g_szIniPath, 0, sizeof(g_szIniPath));
	wcscpy(g_szIniPath, g_szCurrentDirectory);
	wcscat(g_szIniPath, _TEXT("\\"));
	wcscat(g_szIniPath, SETTING_INI);

	// .ini t@Cl̓ǂݍ
	ZeroMemory(&g_szIP, sizeof(g_szIP));

	// IP AhX擾
	if (GetIniFile(_TEXT("IP"), g_szIP, sizeof(g_szIP))) {
		MessageBox(_TEXT("IP ̎擾ɎsB"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
		//VKINIt@C쐬
		WriteIniFile(_TEXT("IP"), _TEXT("01020304"));
	} else {
		//MessageBox(g_szIP, _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
	}

	// 񂩂琔ɕϊ
	swscanf(g_szIP, _TEXT("%x"), &g_dwIP);
	// IPAhXIPAhXRg[ɃZbg
	GetDlgItem(IDC_IPADDRESS1)->SendMessage( IPM_SETADDRESS, 0, g_dwIP );

	// Winsock DLL [h
    if ((dwRet = WSAStartup(MAKEWORD(2,2), &wsaData)) != 0) {
		MessageBox(_TEXT("WSAStartup ̃[hɎsB"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		OnBnClickedOk();
    }

	// ̃_CAO쐬
	m_pdlgWait = new CWaitResp(this);
	m_pdlgWait->Create();
	m_pdlgWait->ShowWindow(SW_HIDE); // ŏ͔\
	m_bdlgWait = FALSE;

	// \Pbgnh
	m_conn_socket = INVALID_SOCKET;

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CH8_JPEGDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CH8_JPEGDlg::OnPaint()
{
	//@ĕ`揈
	if (iPicture) {
		long	hmWidth;
		long	hmHeight;
		CWnd *	hCwnd;
		PAINTSTRUCT ps;
		HDC hDC;
		hCwnd = (CWnd *)this;
		int		iScaleDown = 0;

		hDC = ::BeginPaint(((HWND)(*hCwnd)), &ps);

		//@1 High Metric Point == 0.01mmPʂ̒l擾
		iPicture->get_Width(&hmWidth);
		// 摜̕\TCY`FbN
		if (hmWidth > (LONG)0x4225*0.8)
			iScaleDown = 1;
		iPicture->get_Height(&hmHeight);
		if (hmHeight > (LONG)0x319C*0.8)
			iScaleDown = 1;
				
		// JPEG̃sNZTCYɕϊ
		int iWidth	= ::MulDiv(hmWidth, ::GetDeviceCaps(hDC, LOGPIXELSX), HIMETRIC_INCH);
		int iHeight	= ::MulDiv(hmHeight, ::GetDeviceCaps(hDC, LOGPIXELSY), HIMETRIC_INCH);

		RECT rc;
		::GetClientRect(((HWND)(*hCwnd)), &rc);

		if (iScaleDown) {
			// 傫̂ŁATCY80%ɃXP[_E
			iPicture->Render(hDC, (LONG)18, (LONG)15, (LONG)iWidth*0.8, (LONG)iHeight*0.8, 0, hmHeight, hmWidth, -hmHeight, &rc);
		} else {
			if (iDefault != 0) {
				iPicture->Render(hDC, 18, 15, iWidth, iHeight, 0, hmHeight, hmWidth, -hmHeight, &rc);
			} else {
				iPicture->Render(hDC, 50, 60, iWidth, iHeight, 0, hmHeight, hmWidth, -hmHeight, &rc);
			}
		}	
		//@DC̉
		::EndPaint(((HWND)(*hCwnd)), &ps);
	}

	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CH8_JPEGDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//
// [JԂ擾܂
//
void CH8_JPEGDlg::MyGetLocalTime(TM *pTm)
{
	SYSTEMTIME st;

	memset(g_szNow, 0, sizeof(g_szNow));

    GetLocalTime( &st );
    swprintf( g_szNow, 100, _TEXT("%04d/%02d/%02d %02d:%02d:%02d"), 
		st.wYear, st.wMonth, st.wDay,
		st.wHour, st.wMinute, st.wSecond );

	// [JԂZbg
	pTm->tm_sec = htonl(st.wSecond);
	pTm->tm_min = htonl(st.wMinute);
	pTm->tm_hour = htonl(st.wHour);
	pTm->tm_mday = htonl(st.wDay);
	pTm->tm_mon = htonl(st.wMonth - 1);
	pTm->tm_year = htonl(st.wYear);
	
	if (st.wDayOfWeek == 0) {
		pTm->tm_wday = htonl(6);
	} else {
		pTm->tm_wday = htonl(st.wDayOfWeek - 1);
	}

	//@邤N`FbN
	if (st.wYear % 4 == 0) {
		if (st.wYear % 100 == 0) {
			if (st.wYear % 400 == 0) {
				//MessageBox(_TEXT("leap year!!"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
				pTm->tm_yday = htonl(365);
			} else {
				//MessageBox(_TEXT("Not leap year!!"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
				pTm->tm_yday = htonl(364);
			}
		} else {
			//MessageBox(_TEXT("leap year!!"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
			pTm->tm_yday = htonl(365);
		}
	} else {
		pTm->tm_yday = htonl(364);
	}
}

//
// .ini t@Cɒl݂܂
//
DWORD CH8_JPEGDlg::WriteIniFile(TCHAR *pKey, TCHAR *pValue)
{
	return WritePrivateProfileString(
						_TEXT("H8_LAN"), 
						pKey, 
						pValue, 
						g_szIniPath);
}


//
// .ini t@Cl擾܂
//
DWORD CH8_JPEGDlg::GetIniFile(TCHAR *pKey, TCHAR *pValue, DWORD dwValueLen)
{
	DWORD	dwRet = 0;
	dwRet = GetPrivateProfileString(
						_TEXT("H8_LAN"),
						pKey,
						_T(""),
						pValue,
						dwValueLen, 
						g_szIniPath);

	if (wcslen(pValue) == 0) {
		dwRet = GetLastError();
	} else {
		dwRet = 0;
	}
	return dwRet;
}

//
// ݒt@CɌ݂IPAhXۑ܂
//
void CH8_JPEGDlg::OnBnClickedButtonSaveIni()
{
	DWORD dwRet = 0;
	
	// ݓ͂ĂIPAhX擾܂
	if (GetDlgItem(IDC_IPADDRESS1)->SendMessage( IPM_GETADDRESS, 0, (LPARAM)&g_dwIP )) {
		memset(g_szIP, 0, sizeof(g_szIP));
		// 擾łlۑ
		swprintf( g_szIP,  sizeof(g_szIP), _T("0x%x"), g_dwIP);
		dwRet = WriteIniFile(_TEXT("IP"),g_szIP);
	}
}

//
// w肵ʐ^[h܂
//
void CH8_JPEGDlg::LoadPictureFile(LPCTSTR szFile)
{
	HANDLE	hFile = NULL;
	LPVOID	pvData = NULL;
	DWORD	dwFileSize = 0,
			dwReadBytes = 0;
	HGLOBAL	hGlobal = NULL;
	BOOL	fRet = FALSE;
	IStream	*iStream = NULL;
	CWnd	*hCwnd = (CWnd *)this;;

	// t@CJ
	hFile = CreateFile (
				szFile, 
				GENERIC_READ, 
				0, 
				NULL,
				OPEN_EXISTING, 
				FILE_ATTRIBUTE_NORMAL, 
				NULL);

	if (hFile == INVALID_HANDLE_VALUE) {
		MessageBox(_TEXT("CreateFile failed!"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
	} else {
		// t@CTCY̎擾
		dwFileSize = GetFileSize(hFile, NULL);

		// ̊m
		hGlobal = GlobalAlloc (GPTR, dwFileSize);
		//@bN
		pvData = GlobalLock(hGlobal);

		fRet = ReadFile (
					hFile, 
					pvData, 
					dwFileSize, 
					&dwReadBytes, 
					NULL);
		// bN
		GlobalUnlock(hGlobal);

		//@t@C
		CloseHandle(hFile);
		
		if (fRet == 0) {
			MessageBox(_TEXT("ReadFile failed!"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		} else {
			//@Xg[IuWFNgɃ}bv
			CreateStreamOnHGlobal(hGlobal, TRUE, &iStream);

			// ÕIuWFNg̃`FbN
			if (iPicture) {
				iPicture->Release();
			}

			//@JPEG̃[h
			::OleLoadPicture(iStream, dwFileSize, TRUE, IID_IPicture, (LPVOID*)&iPicture);
			//@Xg[IuWFNg
			iStream->Release();
			//@O̕`폜
			::InvalidateRect(((HWND)(*hCwnd)), NULL, TRUE);
		}
	}
}

//
// vO삵ĂJgfBNgpX擾܂
//
DWORD CH8_JPEGDlg::GetCurrentPath(TCHAR *pPath)
{
	DWORD	dwRet = 0;
	TCHAR	szCurrentDirectory[MAX_PATH];

	if (pPath == NULL)
		return 0;

	memset(szCurrentDirectory, 0, sizeof(szCurrentDirectory));

	dwRet = GetCurrentDirectory(
					MAX_PATH,
					szCurrentDirectory);

	if (dwRet != 0) {
		wcscpy(pPath, szCurrentDirectory);
	}
	return dwRet;
}


//
// JPEG t@CۑtH_̍쐬s܂B
//
DWORD CH8_JPEGDlg::CreateJpegStorFolder(TCHAR *pPath)
{
	DWORD	dwRet = 0;
	TCHAR	szCurrentDirectory[MAX_PATH];
	TCHAR	szStorDirectory[MAX_PATH];

	ZeroMemory(szCurrentDirectory, sizeof(szCurrentDirectory));
	ZeroMemory(szStorDirectory, sizeof(szStorDirectory));

	if (!wcscmp(pPath, _TEXT(""))) {
		// JgfBNg擾
		dwRet = GetCurrentPath(szCurrentDirectory);

		if (dwRet == 0) {
			MessageBox(_TEXT("JgfBNg pX擾ł܂"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
			dwRet = GetLastError();
			return dwRet;
		} else {
			// 擾łpX\
			//MessageBox(szCurrentDirectory, _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
			// 擾łJgpXۑ
			memset(g_szCurrentDirectory, 0, sizeof(g_szCurrentDirectory));
			memcpy(g_szCurrentDirectory, szCurrentDirectory, sizeof(g_szCurrentDirectory));
			wcscpy(szStorDirectory, szCurrentDirectory);
		}
	} else {
		// tH_܂ł̃pX쐬
		wcscpy(szStorDirectory, pPath);
	}
	wcscat(szStorDirectory, _T("\\JPEG"));
	
	// JPEGۑtH_쐬 
	if (CreateDirectory(szStorDirectory, NULL)) {
		//MessageBox(_TEXT("fBNg̍쐬 OK!!"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
		// 쐬łfBNgpXۑ
		memset(g_szStorDirectory, 0, sizeof(g_szStorDirectory));
		memcpy(g_szStorDirectory, szStorDirectory, sizeof(g_szStorDirectory));
		
	} else {
		dwRet = GetLastError();
		if (dwRet == ERROR_ALREADY_EXISTS) {
			//MessageBox(_TEXT("ɃfBNg݂܂"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
			// ɍ쐬ς݁BƂ肠fBNgpXۑ
			memset(g_szStorDirectory, 0, sizeof(g_szStorDirectory));
			memcpy(g_szStorDirectory, szStorDirectory, sizeof(g_szStorDirectory));
		} else if (dwRet == ERROR_PATH_NOT_FOUND) {
			MessageBox(_TEXT("fBNg pXsł"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		} else if (dwRet == ERROR_FILENAME_EXCED_RANGE) {
			MessageBox(_TEXT("fBNg܂"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		} else {
			MessageBox(_TEXT("sȃG[R[hł"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		}
	}
	return dwRet;
}

//
//@ݒ肳ĂIPAhXɐڑs܂
//
DWORD CH8_JPEGDlg::ResoluveIP()
{
	DWORD		dwAddr;
	CHAR		szIP[32];
	DWORD		dwRet = 0;
	char		hoststr[NI_MAXHOST],
				servstr[NI_MAXSERV];

	struct addrinfo		*results = NULL, 
						*addrptr = NULL, 
						hints;

	memset(szIP, 0, sizeof(szIP));

	GetDlgItem(IDC_IPADDRESS1)->SendMessage( IPM_GETADDRESS, 0, (LPARAM)&dwAddr );
	
	// IPAhX擾
	sprintf(szIP, "%d.%d.%d.%d", 
				(dwAddr >> 24) & 0x000000FF,
				(dwAddr >> 16) &0x000000FF,
				(dwAddr >> 8) & 0x000000FF,
				(dwAddr & 0x000000FF));

	// \Pbg\̂̏Zbg
	memset(&hints, 0, sizeof(hints));
    hints.ai_family = AF_INET;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_protocol = IPPROTO_TCP;

    dwRet = getaddrinfo(
				szIP,
				CTRL_PORT,
				&hints,
				&results);

    if (dwRet != 0) {
        MessageBox(_TEXT("getaddrinfo failed!"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
    }

	addrptr = results;
	//@C^[tF[X
    while (addrptr) {
		//@\Pbg쐬
        m_conn_socket = socket(addrptr->ai_family, addrptr->ai_socktype, addrptr->ai_protocol);
        if (m_conn_socket == INVALID_SOCKET) {
			MessageBox(_TEXT("socket failed!"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
			break;
        }
		//@ڑ擾
        dwRet = getnameinfo(
					addrptr->ai_addr,
					(socklen_t)addrptr->ai_addrlen,
					hoststr,
					NI_MAXHOST,
					servstr,
					NI_MAXSERV,
					NI_NUMERICHOST | NI_NUMERICSERV);
        if (dwRet != 0) {
			MessageBox(_TEXT("getnameinfo failed!"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
			break;
        }

		//@ڑv
        dwRet = connect(m_conn_socket, addrptr->ai_addr, (int)addrptr->ai_addrlen);
        if (dwRet == SOCKET_ERROR) {
			closesocket(m_conn_socket);
			m_conn_socket = INVALID_SOCKET;
			addrptr = addrptr->ai_next;
		} else {
			//@ڑI
			//MessageBox(_TEXT("ڑ"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
			break;
		}
    }

	//@ڑ
    freeaddrinfo(results);
    results = NULL;

	if (m_conn_socket == INVALID_SOCKET) {
		MessageBox(_TEXT("connect failed!"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
    } else {
       //MessageBox(_TEXT("ڑ"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
	}
	return dwRet;
}

//
// ڑmĂꍇ͐ؒfs܂
//
DWORD CH8_JPEGDlg::EndConnection()
{
	DWORD dwRet = 0;

	dwRet = shutdown(m_conn_socket, SD_BOTH);
	if (dwRet != SOCKET_ERROR) {
		closesocket(m_conn_socket);
		m_conn_socket = INVALID_SOCKET;
	}
	return dwRet;
}


void CH8_JPEGDlg::OnBnClickedOk()
{
	//@Sׂ̈ɐڑ󋵂`FbN܂
	if (m_conn_socket != INVALID_SOCKET) {
		shutdown(m_conn_socket, SD_BOTH);
		closesocket(m_conn_socket);
		m_conn_socket = INVALID_SOCKET;
	}

	//@\PbgDLLJ
	WSACleanup();
	
	OnOK();
}

//
// JPEGt@CJ܂
//
void CH8_JPEGDlg::OnBnClickedButtonOpenJpegFile()
{
	CString	JpegFileName;

	// R_CAO\
	CFileDialog SelectDlg(TRUE,_TEXT("*"),_TEXT("*.jpg"),OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,_TEXT("JPEGt@C(*.jpg)"));

	if (SelectDlg.DoModal() == IDOK){
		JpegFileName = SelectDlg.GetPathName();
		LoadPictureFile(JpegFileName);
		iDefault = 1;
	}	
}

void CH8_JPEGDlg::OnBnClickedCancel()
{
	//@Sׂ̈ɐڑ`FbN܂
	if (m_conn_socket != INVALID_SOCKET) {
		shutdown(m_conn_socket, SD_BOTH);
		closesocket(m_conn_socket);
		m_conn_socket = INVALID_SOCKET;
	}

	//@\PbgDLLJ
	WSACleanup();

	OnCancel();
}

//
// ҂̃bZ[Ww肵҂Ԉȏo߂ꍇ́A
// ҂Ԃ̃bZ[W폜܂
//
void CH8_JPEGDlg::RemoveMessage(DWORD	dwWait)
{

	DWORD	dwCurrent = 0,
			dwTimeout = 0;
	MSG		msg;

	dwTimeout = GetTickCount();
	dwTimeout = dwTimeout + dwWait;

	while (1) {
		if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
			//bZ[WWM_QUITȂ烋[v𔲂
			if (msg.message == WM_QUIT)
				break ;
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
		dwCurrent = GetTickCount();
		if (dwCurrent > dwTimeout) {
			break;
		}
	}
}


//
// JR}hNGXg܂
//
void CH8_JPEGDlg::OnBnClickedButtonCameraInit()
{
	DWORD		dwRet = 0;
	CButton		*button = (CButton*)GetDlgItem(IDC_BUTTON_CAMERA_INIT);
	CInitCamera	*pInitCamera = new CInitCamera();

	// IP AhXĐڑs
	dwRet = ResoluveIP();
	if (dwRet != 0) {
		// G[
		return;
	}

	button->EnableWindow(FALSE);

	//@J̏
	dwRet = pInitCamera->InitAction(m_conn_socket, m_pdlgWait);

	//m_pdlgWait->ShowWindow(SW_HIDE);

	delete pInitCamera;
	
	// ؒf
	EndConnection();
	
	if (dwRet == WSA_WAIT_FAILED || dwRet == WSA_WAIT_TIMEOUT) {
		MessageBox(_TEXT("J̏Ɏs܂B"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
	} else {
		MessageBox(_TEXT("J̏܂B"), _TEXT("INFO"), MB_OK | MB_ICONINFORMATION);
		// 񏉊̂h~邽ߏ{^𖳌ɂ
		//button->EnableWindow(FALSE);;
	}
	button->EnableWindow(TRUE);
}

//
// ʐ^擾郊NGXg𑗐M܂
//
void CH8_JPEGDlg::OnBnClickedButtonGetPicture()
{	
	DWORD		dwRet = 0;
	CGetPicture	*pGetPic = new CGetPicture();
	TCHAR		szJpegFileName[MAX_PATH];
	CStatic *MyStatic = (CStatic*)GetDlgItem(IDC_STATIC_FILENAME);
	CButton *button = (CButton*)GetDlgItem(IDC_BUTTON_GET_PICTURE);
	
	// IP AhXĐڑs
	dwRet = ResoluveIP();

	if (dwRet != 0) {
		// G[
		return;
	}

	memset(szJpegFileName, 0, sizeof(szJpegFileName));

	// tH_pXZbg
	wcscpy(szJpegFileName, g_szStorDirectory);

	button->EnableWindow(FALSE);

	//@ʐ^̎擾
	dwRet = pGetPic->GetPicAction(m_conn_socket, m_pdlgWait, szJpegFileName);
	//@摜擾łĂꍇUIɕ\
	if (szJpegFileName[0] != 0) {
		iDefault = 1;
		// Mt@Cǂ݂ĕ\
		LoadPictureFile(szJpegFileName);
		MyStatic->SetWindowText(szJpegFileName);
	}
	delete pGetPic;
	EndConnection();
	RemoveMessage(1000);
	button->EnableWindow(TRUE);
}


void CH8_JPEGDlg::OnBnClickedButtonDisconnect()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
}
