// InitCamera.cpp : t@C
//

#include "stdafx.h"
#include "H8_JPEG.h"
#include "InitCamera.h"
#include "H8_JPEGDlg.h"
#include "WaitResp.h"

#include <winsock2.h>

// CInitCamera _CAO

IMPLEMENT_DYNAMIC(CInitCamera, CDialog)

CInitCamera::CInitCamera(CWnd* pParent /*=NULL*/)
	: CDialog(CInitCamera::IDD, pParent)
{
}

CInitCamera::~CInitCamera()
{
}

void CInitCamera::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CInitCamera, CDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CInitCamera bZ[W nh


void CInitCamera::OnPaint()
{
	CDialog::OnPaint();
}

// J̏R}h𔭍s



DWORD CInitCamera::InitAction(SOCKET connect_socket, CWaitResp*	m_pdlgWait)
{
	int		iTmp;
	DWORD	dwRet = 0;
	char	*pPacket;

	H8_CONTROL_PACKET	*pH8_PKT = NULL;

	// MCxg֘A
	HANDLE  hEvent = NULL;
	WSANETWORKEVENTS    events;
	//DWORD	dwTimeout = 60000;		//@^CAEg60b(ʏ25bxŏł)
	DWORD	dwTimeout = 30000;		//@^CAEg30b(ʏ25bxŏł)


	hEvent = WSACreateEvent();

	iTmp = sizeof(H8_CONTROL_PACKET);
	pH8_PKT = (H8_CONTROL_PACKET *)malloc(iTmp);
	
	memset(pH8_PKT, 0, iTmp);

	pH8_PKT->CommandCode = htonl(C1098_INIT);
	pH8_PKT->DataType = htonl(TYPE_IMAGE_DATA);

	pPacket = (char *)pH8_PKT;

	// R}hM
	dwRet = send(connect_socket,
				pPacket,
				iTmp,
				0);

	if (dwRet == SOCKET_ERROR) {
		MessageBox(_TEXT("J̏R}hMł܂B"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		goto END_CLEANUP;
	}

	//@̃bZ[W\܂B
	if (m_pdlgWait) {
		m_pdlgWait->SetStaticID(1);
		m_pdlgWait->ShowWindow(SW_SHOW);
	}
	
	//@Mؒf̃Cxgݒ
	WSAEventSelect(connect_socket,
				hEvent,
				FD_READ | FD_CLOSE);

	//@Cxg҂
	dwRet = WSAWaitForMultipleEvents(1,
					&hEvent,
					FALSE,
					dwTimeout,
					FALSE);

	if (dwRet == WSA_WAIT_FAILED) {
		m_pdlgWait->ShowWindow(SW_HIDE);
		MessageBox(_TEXT("WSAWaitForMultipleEvents failed"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		goto END_CLEANUP;
	} else if (dwRet == WSA_WAIT_TIMEOUT) {
		m_pdlgWait->ShowWindow(SW_HIDE);
		MessageBox(_TEXT("M^CAEg܂B"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		goto END_CLEANUP;
	}

	// Cxg̎ނ擾
	dwRet = WSAEnumNetworkEvents(connect_socket,hEvent,&events);

	if (dwRet == SOCKET_ERROR) {
		m_pdlgWait->ShowWindow(SW_HIDE);
		MessageBox(_TEXT("WSAEnumNetworkEvents failed"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		goto END_CLEANUP;
	}

	if (events.lNetworkEvents & FD_CLOSE) {
		m_pdlgWait->ShowWindow(SW_HIDE);
		MessageBox(_TEXT("ؒf܂B"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
		goto END_CLEANUP;

	} else if (events.lNetworkEvents & FD_READ) {

		memset(pPacket, 0, iTmp);
		dwRet = recv(connect_socket,
					pPacket,
					iTmp,
					0);

		if (dwRet == SOCKET_ERROR) {
			if (m_pdlgWait) {
				m_pdlgWait->ShowWindow(SW_HIDE);
			}
			m_pdlgWait->ShowWindow(SW_HIDE);
			MessageBox(_TEXT("J̏R}hɑ΂ĉ܂B"), _TEXT("ERROR"), MB_OK | MB_ICONERROR);
			goto END_CLEANUP;
		}
		m_pdlgWait->ShowWindow(SW_HIDE);
	}

END_CLEANUP:

	if (hEvent != NULL) {
		WSACloseEvent(hEvent);
		hEvent = NULL;
	}
	
	if (pH8_PKT != NULL) {
		free(pH8_PKT);
		pH8_PKT = NULL;
	}
	return dwRet;
}


